<!-- refund 维权信息  -->
<template>
  <div>
    <el-dialog :append-to-body="true" :close-on-click-modal="false" title="维权信息" :visible.sync="Show" width="800px">
      <div>

        <el-form :model="formData" :rules="m_rules" ref="ruleForm">
          <div class="flex flex-m flex-b">
            <el-form-item label="状态" label-width="100px" prop="name">
              <span class="fs18"> <span :class="info.status|status">{{info.status | BaseData('refund','status')}}</span></span>
            </el-form-item>

            <el-form-item label="售后号" label-width="100px" prop="name">
              <span> {{info.refund_no  }}</span>
            </el-form-item>
          </div>

          <div class="flex flex-m">
            <el-form-item class="flex-1" label="类型" label-width="100px" prop="name">
              <span>{{info.apply_type | BaseData('refund','apply_type') }}</span>
            </el-form-item>

            <el-form-item class="flex-1" v-if="info.refund_amount" label="退款金额" label-width="100px" prop="name">
              <span class="m_red">¥ {{info.refund_amount  }}</span>
            </el-form-item>

            <el-form-item class="flex-1" label="创建时间" label-width="100px" prop="name">
              <span>{{info.created_at  }}</span>
            </el-form-item>
          </div>

          <el-form-item class="flex-1" v-if="info.refund_credit.length" label="凭证" label-width="100px" prop="name">
            <div v-viewer>
              <img class="imgClass" v-for="(src , index) in info.refund_credit" :src="src" :key="index">
            </div>
          </el-form-item>

          <el-form-item class="flex-1" label="退款说明" label-width="100px" prop="name">
            <span> {{info.reason  }}</span>
          </el-form-item>

          <el-form-item label="退款处理" label-width="100px" prop="refund_result">
            <el-select v-model="formData.refund_result">
               <el-option value="0" label="请选择" ></el-option>
              <el-option v-for="item in  getList" :value="item.id" :label="item.name" :key="item.id"></el-option>
            </el-select>
          </el-form-item>
          <div v-if="info.apply_type  !=2">
            <div class="flex flex-m">

              <el-form-item class="flex-1" label="退货收件人" label-width="100px" prop="receiver">
                <el-input class="w200" clearable v-model="formData.receiver" auto-complete="off"></el-input>
              </el-form-item>

              <el-form-item class="flex-1" label="退货联系方式" label-width="100px" prop="receiver_mobile">
                <el-input class="w200" clearable v-model="formData.receiver_mobile" auto-complete="off"></el-input>
              </el-form-item>
            </div>

            <el-form-item label="省市区" label-width="100px">
              <el-cascader class="w100p" :options="options" v-model="selectedOptions" @change="handleChange"></el-cascader>
            </el-form-item>

            <el-form-item label="地址" label-width="100px" prop="address">
              <el-input type="textarea" clearable v-model="formData.address" auto-complete="off"></el-input>
            </el-form-item>

          </div>

        </el-form>
      </div>
      <div slot="footer">
        <el-button @click="Show = false">关 闭</el-button>
        <el-button type="primary" @click="sureOption">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { regionData } from 'element-china-area-data'
import * as utils from '@/utils/index'
export default {
  name: 'refund',
  props: {
    value: {
      required: true,
      type: Boolean,
    },
    id: {
      type: [String, Number]
    },
    order_info: {},

  },

  computed: {
    Show: {
      get() {
        return this.value
      },
      set(v) {
        this.$emit('input', v)
      },

    },

      getList() {
      let apply_type = this.info.apply_type
      let list = this.GetBaseData('refund', 'refund_result') || []
      let arr = []
      if (apply_type == 1) {
        //退款&退货
        return list
      }
      if (apply_type == 2) {
        //退款
        arr = ['1', '3', '4']
      }
      if (apply_type == 3) {
        //换货
        arr = ['1', '2', '5']

      }
      return list.filter(i => {
        return arr.includes(i.id)
      })
    }
  },
  data() {
    return {
      options: regionData, //省市数据
      m_tableLoading: false,
      selectedOptions: [],
      formData: {
        refund_id: '', //
        refund_result: '', //参考字典:refund.refund_result
        receiver: '', //退货收件人(通过申请状态必填)
        receiver_mobile: '', //退货收件人联系范式
        province: '', //省
        city: '', //市
        area: '', //区
        address: '', //详细地址



      },

      m_rules: {
        title: { required: true, message: '请输入', trigger: 'blur' },

      },
      info: {
        refund_credit: []
      }
    }
  },

  mounted() {
    this.init()
  },


  methods: {
    //初始化方法
    init() {
      this.getInfo()
    },

    getInfo() {
      this.m_tableLoading = true
      this.m_api.refund_detail({ refund_id: this.id }).then(res => {
        this.info = res.data
        this.formData = utils.coverObj(this.formData, this.info)
        this.formData.refund_id = this.info.id
        this.selectedOptions = [this.info.province, this.info.city, this.info.area]
        this.m_tableLoading = false
      }).catch(err => {
        this.m_tableLoading = false
      })
    },

    //省市选择
    handleChange(value) {
      console.log(value)
      this.formData.province = value[0]
      this.formData.city = value[1]
      this.formData.area = value[2]
    },

    //编辑新增数据 点击确定
    sureOption() {
      this.$refs['ruleForm'].validate((valid) => {
        if (valid) {
          if (this.m_isadd) {
            this.loading = true
            this.m_api.refund_set_status(this.formData).then(res => {
              this.m_success('操作成功')
              this.loading = false
              this.handelSetMenu()

            }).catch(err => {
              this.loading = false

            })
          }
        } else {
          console.log('error submit!!');
          return false;
        }
      })

    },

    handelSetMenu() {
      this.$emit('save-after')
      this.Show = false
    },
  },
  watch: {

  },
  filters: {
    status(v) {
      if (v == 0) { return 'm_red' }
    }
  }
}

</script>
<style lang='scss' scoped>
.imgClass {
  width: 50px;
  height: 50px;
  margin-right: 10px;
  margin-bottom: 10px;
}
</style>